
#include <vcl.h>
#include "uart.h"
#include "I7000.h"

char gcPort;         //Global Char
long gwBaudRate;     //Global Word
long gdwBaudRate;
Word gwCheckSum;
char gcDataBit, gcParity, gcStopBit;

char gszSend[80];    //Global StringZ
char gszReceive[80]; 

float gfInData[1000]; //Global Float
Word  gw7000[11];
float gf7000[11];


//*************************************
void IFillWordArray04(Word *wArray, Word wVal0, Word wVal1, Word wVal2, Word wVal3, Word wVal4)
{
	wArray[0]=wVal0;
	wArray[1]=wVal1;
	wArray[2]=wVal2;
	wArray[3]=wVal3;
	wArray[4]=wVal4;
}

//*************************************
void IFillWordArray59(Word *wArray, Word wVal5, Word wVal6, Word wVal7, Word wVal8, Word wVal9)
{
	wArray[5]=wVal5;
	wArray[6]=wVal6;
	wArray[7]=wVal7;
	wArray[8]=wVal8;
	wArray[9]=wVal9;
}

//*************************************
void IFillFloatArray04(float *fArray, float fVal0, float fVal1, float fVal2, float fVal3, float fVal4)
{
	fArray[0]=fVal0;
	fArray[1]=fVal1;
	fArray[2]=fVal2;
	fArray[3]=fVal3;
	fArray[4]=fVal4;
}

//*************************************
void IFillFloatArray59(float *fArray, float fVal5, float fVal6, float fVal7, float fVal8, float fVal9)
{
	fArray[5]=fVal5;
	fArray[6]=fVal6;
	fArray[7]=fVal7;
	fArray[8]=fVal8;
	fArray[9]=fVal9;
}

//*************************************
Word IOpenCom(char cComPort, DWORD dwBaudRate)
{
	return Open_Com( cComPort, dwBaudRate, 8, 0 , 0 );
}


//*************************************
void ISetCOMString(TComboBox *cb, int iStart, int iEnd)
{
   int i;

   cb->Items->Clear();
   for (i=iStart;i<=iEnd;i++)
         cb->Items->Add( "COM" + IntToStr(i) );
   cb->ItemIndex = 0;

}

//*************************************
void ISetBaudRateString(TComboBox *cb)
{
     cb->Items->Clear();
     cb->Items->Add("115200");
     cb->Items->Add("57600");
     cb->Items->Add("38400");
     cb->Items->Add("19200");
     cb->Items->Add("9600");
     cb->Items->Add("4800");
     cb->Items->Add("2400");
     cb->Items->Add("1200");
     cb->ItemIndex = 0;
}

//*************************************
AnsiString GetErrorString(Word wErrCode)
{
    AnsiString ErrString;
    
    switch (wErrCode) {
	case 0: ErrString = "No Error" ;                   break;
	case 1: ErrString = "Function Error";              break;
	case 2: ErrString = "Port Error";                  break;
	case 3: ErrString = "Baud Rate Error";             break;
	case 4: ErrString = "Data Error";                  break;
	case 5: ErrString = "Stop Error";                  break;
	case 6: ErrString = "Parity Error";                break;
	case 7: ErrString = "CheckSum Error";              break;
	case 8: ErrString = "Not Open";                    break;
	case 9: ErrString = "Send Thread Create Error";    break;
	case 10: ErrString = "Send Command Error";         break;
	case 11: ErrString = "Read Com Port Status Error"; break;
	case 12: ErrString = "Result String Check Error";  break;
	case 13: ErrString = "Command Error";              break;
	//case 14: ErrString = ""; break;
	case 15: ErrString = "Time Out";                   break;
	//case 16: ErrString = ""; break;
	case 17: ErrString = "Module Id Error";            break;
	case 18: ErrString = "AD Channel Error";           break;
	case 19: ErrString = "Under Input Range";          break;
	case 20: ErrString = "Exceed Input Range";         break;
	case 21: ErrString = "Invalidate Counter No";      break;
	case 22: ErrString = "Invalidate Counter Value";   break;
	case 23: ErrString = "Invalidate Gate Mode";       break;
        default :
                 ErrString = "Unknown Error";              break;
    }
    return ErrString ;
}

AnsiString IGetErrorString(Word wErrCode)
{
	return GetErrorString( wErrCode );
} 

//*************************************
