Attribute VB_Name = "i7000u"
Option Explicit

Global Const cstDataFormat_Engineer = 0
Global Const cstDataFormat_FSR = 1
Global Const cstDataFormat_HEX = 2

'C@ӼҲճ]w\BѳOΥHUܼƪe
'䤺eŧibU@IIa
Global gsSet_InitError As String
Global gsSet_Ok As String


'------------------------ Win32 API ---------------------------
Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Long) As Long
Declare Function GetTickCount Lib "kernel32" () As Long
Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Declare Function OpenFile Lib "kernel32" (ByVal lpFileName As String, lpReOpenBuff As OFSTRUCT, ByVal wStyle As Long) As Long
Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer
Declare Function RealizePalette Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Public Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Boolean

Public Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
Public Declare Function GetPrivateProfileInt Lib "kernel32" Alias "GetPrivateProfileIntA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal nDefault As Long, ByVal lpFileName As String) As Long
Public Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long



'Public Const EM_LINESCROLL = &HB6
Public Declare Function SendMessageBynum Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Public Monitor_Log As String
Type OSVERSIONINFO
    dwOSVersionInfoSize As Long
    dwMajorVersion As Long
    dwMinorVersion As Long
    dwBuildNumber As Long
    dwPlatformId As Long
    szCSDVersion As String * 128
End Type

Public Const VER_PLATFORM_WIN32s = 0
Public Const VER_PLATFORM_WIN32_WINDOWS = 1
Public Const VER_PLATFORM_WIN32_NT = 2



Type Point
    x As Single
    y As Single
End Type


Type SystemTime
 wYear As Integer
 wMonth As Integer
 wDayOfWeek As Integer
 wDay As Integer
 wHour As Integer
 wMinute As Integer
 wSecond As Integer
 wMilliseconds As Integer
End Type
Declare Sub GetLocalTime Lib "kernel32" (lpSystemTime As SystemTime)


'------------------------ Message ID ---------------------
Global Const WM_USER = &H400
Global Const EM_SETREADONLY = (WM_USER + 31)
Global Const EM_LINESCROLL = &HB6

Type ModuleIOChannel
DIChannel As Integer
DOChannel As Integer
AIChannel As Integer
AOChannel As Integer
End Type

Global gMIOChannel As ModuleIOChannel
Type MultiSlewRate
    slewRate(0 To 7) As Byte
End Type

Type CFConfig
    mode(0 To 7) As Integer
    DataFormat(0 To 7) As Integer
End Type

Type MultiType
    typeCode(0 To 7) As Byte
End Type
Type ModuleConfigType
    protocol        As Integer
    protocolInEEP  As Integer
    Description As String
    OnlyDCON As Boolean
    FilterSetting     As Byte      ' 0:60Hz rejection, 1:50Hz rejection
    ModuleType        As String * 10 '7017, 7018, 7033 .....uƦr
    ModuleSpecialFunction      As String * 5  'OҲժS\AҦp 7017C  C
    OperationPrefix   As String * 10
    BaudRate          As Long
    ModuleAddress     As Integer
    inputRange        As Byte      ' 7080 for Counter and Frequence
    InputRange2       As Byte      ' for second channel of 7022
    InputRangeCode    As Byte      ' 7011, 7012, 7014  !aaTTccff   ->TT(Decimal)
    MultiRangeCode As MultiType
    Checksum          As Byte
    format            As Byte      ' 7080 Freq mode, 0.1 or 1.0 seconds,
    slewRate          As Byte      ' 7021 only
    SlewRate2         As Byte      ' for second channel of 7022
    slot              As Byte      ' for 8000 Series
    ChannelSelect     As Integer   ' ' for AI module channel enable/disable status
    DDEInit           As Integer
    LedChannel        As Integer   ' 7033 for LED channel
    DigitalInOutType  As Integer   ' 0:No  1:In  2:Out
                                     ' for 7080 use, Counter Gate Mode
                                     ' 0: Low,  1: High,  2: None
    DigitalOutData    As Integer   ' the data to output
    Value             As Single    ' 7021 output value
    value2            As Single    ' for second channel of 7022
    '--- The following element is for 8024 ---
    OutputRange8024(0 To 3)  As Byte
    SlewRate8024(0 To 3)    As Byte
    Value8024(0 To 3)       As Single
    
    '--- The following element is for 7080 ---
    ModuleAlarmMode           As Integer
    CounterStatus(0 To 1)     As Integer
    CounterClearCount(0 To 1) As Integer
    CounterPresetCount(0 To 1) As Double
    CounterMaxCount(0 To 1)   As Double
    CounterAlarmState(0 To 1) As Integer
    CounterAlarmValue(0 To 1) As Double
    CounterSignalMode(0 To 1) As Integer
    CounterHighLevelVolt      As Single  '7011, 7012, 7014 High Alarm Limit Value
    CounterLowLevelVolt       As Single  '7011, 7012, 7014 Low Alarm Limit Value
    HighLevelMinWidth         As Long
    LowLevelMinWidth          As Long
End Type

' Determining whether a file already exist, please see MSDN VB Tip 162
Public Const OFS_MAXPATHNAME = 128
Type OFSTRUCT
    cBytes     As Byte
    fFixedDisk As Byte
    nErrCode   As Integer
    Reserved1  As Integer
    Reserved2  As Integer
    szPathName(OFS_MAXPATHNAME) As Byte
End Type

Type InputData
    InputS(0 To 7) As String
End Type
Type OutputData
    OutputS(0 To 7) As String
End Type

Type inputRange
    indexR     As Integer
    strR As String
End Type

Type MultiInputRange
    indexR(0 To 30)     As Integer
    strR(0 To 30) As String
End Type

Type DOChMap 'for 7005 DO Alarm mapping use each DO can be assigned to By many channel
    HighCh(0 To 7) As Integer
    LowCh(0 To 7) As Integer
End Type

Type DOAlarmMap 'for 7005 DO Alarm mapping use each DO can be assigned to By many channel
    HighAlarmCh(0 To 7) As Integer
    LowAlarmCh(0 To 7) As Integer
End Type

Global ModuleConfig(0 To 255) As ModuleConfigType  ' Max 256 Module
Global g8050msg As Integer
Global gBaudRateTable(0 To 15) As Long
Global gBaudRateStr(0 To 15) As String
Global gBaudRateIndex As Integer
Global gInputRangeIndex As Integer
Global gHzRejection(0 To 1) As String
Global gDataFormat(0 To 3) As String
Global g87KArray(0 To 2500) As Integer
Global loopcount As Long
Global i87082flag As Integer
Global hostIP As String        ' for wincon to connect DCON_CE
Global targetPath As String  'for wincon to execute DCON_CE

Global SendTo7000 As String
Global ReceiveFrom7000  As String
Global SendTo8000 As String
Global ReceiveFrom8000  As String
Global dwBuf(0 To 20) As Long
Global wBuf(0 To 20) As Integer
Global w7000(0 To 20) As Integer
Global f7000(0 To 11) As Single
Global dw8000(0 To 11) As Long
Global dw7000(0 To 11) As Long
Global f8000(0 To 11) As Single
Global fBuf(0 To 20) As Single
Global gPort     As Integer        ' the select COM Port
Global gBaudRateSelect As Integer  ' the select baudrateS
'ϥΤGiӪܡAC@BitܨϥΪBaudRate
'nfrmCOM.frm}CIndex
'2^0: 921600   2^1: 460800  2^2: 230400  2^3: 115200
'2^4:  57600   2^5:  38400  2^6:  19200  2^7:   9600
'2^8:   4800   2^9:   2400  2^10:  1200

Global gChecksumSearch As Integer   ' 0: not to search   1: to search

Global gBaudRate As Long
Global gBaudrateCheck(0 To 10) As Byte
Global gSetupModuleIndex As Integer
Global gActiveCount As Integer
Global gFoundCount As Integer  ' How many module be found out
Global telnetOpen As Boolean
Global gTickWinCon As Long
Global gValue As Single            '7021 Digital Output
Global gDigitalInOutType As Integer    'indicate digital In/Out 0:No, 1:In, 2:Out
Global gDigitalOutData As Integer  'the data to digital output
Global gRightButton
Global gStopSearch As Integer  ' form 4, decide to stop search module
Global gOpenCount, gCloseCount  As Integer
Global gModuleInformation(0 To 255) As String * 80  ' stored the found out module information
Global gTimeoutTick As Integer
Global Const gconUtilityTitle As String = "DCON Utility"
Global Const gAboutTitle As String = "About DCON Utility..."
Global gsSlewRate_Voltage(15) As String
Global gsSlewRate_Current(15) As String
Global gsRangeCode(200) As String
Global gWinCon As Integer
Global gModbusArray(0 To 255) As Integer 's modbus if 1 modbus protocol else dcon

Global gItemX As ListItem    ' the now selected listitem

Global DIReverseFlag As Byte  'DIO Ҳ DI iH]wn HiO1 or Low O1


Public Sub Main()
    
    App.HelpFile = App.Path & "\icpcon.hlp"
    
    gsSet_InitError = "Please connect Init* to GND." & vbCrLf & _
                      "Then click [Setting] again !!!"
    gsSet_Ok = "Set configguration ok !!!" & vbCrLf & _
               "Please turn off power of the module," & vbCrLf + _
               "then turn it on again to take effect the setting !!!"
    gWinCon = 0
    Form2.Show
    DoEvents
    Form2.MousePointer = 11
    Sleep 3000
 
    ReadCfgFile ' Reading ICPCON.CFG file
    Monitor_Log = "Monitor_Log"
    Unload Form2
    MDIForm1.Show
    frmStartSearch.Show
    
    gsSlewRate_Voltage(0) = "immediate change"
    gsSlewRate_Voltage(1) = "0.0625 V/sec"
    gsSlewRate_Voltage(2) = "0.125 V/sec"
    gsSlewRate_Voltage(3) = "0.250 V/sec"
    gsSlewRate_Voltage(4) = "0.500 V/sec"
    gsSlewRate_Voltage(5) = "1.000 V/sec"
    gsSlewRate_Voltage(6) = "2.000 V/sec"
    gsSlewRate_Voltage(7) = "4.000 V/sec"
    gsSlewRate_Voltage(8) = "8.000 V/sec"
    gsSlewRate_Voltage(9) = "16.00 V/sec"
    gsSlewRate_Voltage(10) = "32.00 V/sec"
    gsSlewRate_Voltage(11) = "64.00 V/sec"
    gsSlewRate_Voltage(12) = "128.0 V/sec"
    gsSlewRate_Voltage(13) = "256.0 V/sec"
    gsSlewRate_Voltage(14) = "512.0 V/sec"
    gsSlewRate_Voltage(15) = "1024.0 V/sec"
    
    gsSlewRate_Current(0) = "immediate change"
    gsSlewRate_Current(1) = " 0.125 mA/sec"
    gsSlewRate_Current(2) = " 0.250 mA/sec"
    gsSlewRate_Current(3) = " 0.500 mA/sec"
    gsSlewRate_Current(4) = " 1.000 mA/sec"
    gsSlewRate_Current(5) = " 2.000 mA/sec"
    gsSlewRate_Current(6) = " 4.000 mA/sec"
    gsSlewRate_Current(7) = " 8.000 mA/sec"
    gsSlewRate_Current(8) = "16.000 mA/sec"
    gsSlewRate_Current(9) = "32.000 mA/sec"
    gsSlewRate_Current(10) = "64.000 mA/sec"
    gsSlewRate_Current(11) = "128.00 mA/sec"
    gsSlewRate_Current(12) = "256.00 mA/sec"
    gsSlewRate_Current(13) = "512.00 mA/sec"
    gsSlewRate_Current(14) = "1024.0 mA/sec"
    gsSlewRate_Current(15) = "2048.0 mA/sec"
    
    gsRangeCode(0) = "+/- 15 mV"
    gsRangeCode(1) = "+/- 50 mV"
    gsRangeCode(2) = "+/- 100 mV"
    gsRangeCode(3) = "+/- 500 mV"
    gsRangeCode(4) = "+/- 1.0 V"
    gsRangeCode(5) = "+/- 2.5 V"
    gsRangeCode(6) = "+/- 20 mA"
    gsRangeCode(7) = "+/- 1.25 V"
    gsRangeCode(8) = "+/- 10 V"
    gsRangeCode(9) = "+/- 5 V"
    gsRangeCode(&HA) = "+/- 1 V"
    gsRangeCode(&HB) = "+/- 500 mV"
    gsRangeCode(&HC) = "+/- 150 mV"
    gsRangeCode(&HD) = "+/- 20 mA"
    gsRangeCode(&HE) = "T/C J-type"
    gsRangeCode(&HF) = "T/C K-type"
    gsRangeCode(&H10) = "T/C T-type"
    gsRangeCode(&H11) = "T/C E-type"
    gsRangeCode(&H12) = "T/C R-type"
    gsRangeCode(&H13) = "T/C S-type"
    gsRangeCode(&H14) = "T/C B-type"
    gsRangeCode(&H15) = "T/C N-type"
    gsRangeCode(&H16) = "T/C C-type"
    gsRangeCode(&H17) = "T/C L-type"
    gsRangeCode(&H18) = "T/C M-type"
    gsRangeCode(&H19) = "T/C L2-type"
    gsRangeCode(&H20) = "+/- 100 ,PT 100 \=0.00385"
    gsRangeCode(&H21) = "0 ~ +100 ,PT 100 \=0.00385"
    gsRangeCode(&H22) = "0 ~ +200 ,PT 100 \=0.00385"
    gsRangeCode(&H23) = "0 ~ +600 ,PT 100 \=0.00385"
    gsRangeCode(&H24) = "+/- 100 ,PT 100 \=0.003916"
    gsRangeCode(&H25) = "0 ~ +100 ,PT 100 \=0.003916"
    gsRangeCode(&H26) = "0 ~ +200 ,PT 100 \=0.003916"
    gsRangeCode(&H27) = "0 ~ +600 ,PT 100 \=0.003916"
    gsRangeCode(&H28) = "-80 ~ +600 ,Nickel 120"
    gsRangeCode(&H29) = "0 ~ +100 ,Nickel 120"
    gsRangeCode(&H2A) = "-200 ~ +600 ,PT 1000 \=0.00385"
    gsRangeCode(&H2B) = "-20 ~ 150 ,Cu 100 @ 0XC,\= 0.00421"
    gsRangeCode(&H2C) = "0 ~ 200 ,Cu 100 @ 25XC,\= 0.00427"
    gsRangeCode(&H2D) = "-20 ~ 150 ,Cu 1000 @ 0XC,\= 0.00421"
    
    gsRangeCode(&H2E) = "-200 ~ +200XC ,PT 100 ,\= 0.00385"
    gsRangeCode(&H2F) = "-200 ~ +200XC ,PT 100 ,\= 0.003916"
    gsRangeCode(&H80) = "-200 ~ +600XC ,PT 100 ,\= 0.00385"
    gsRangeCode(&H81) = "-200 ~ +600XC ,PT 100 ,\= 0.003916"

    gsRangeCode(&H30) = "0 ~ +20 mA"
    gsRangeCode(&H31) = "+4 ~ +20 mA"
    gsRangeCode(&H32) = "0 ~ +10 V"
    gsRangeCode(&H33) = "+/- 10 V"
    gsRangeCode(&H34) = "0 ~ +5 V"
    gsRangeCode(&H35) = "+/- 5 V"
    gsRangeCode(&H60) = "Precon --ST-A3 -30 ~ +240 Fahrenheit"
    gsRangeCode(&H61) = "Type u Fenwell -50 ~ +150 Celisus"
    gsRangeCode(&H62) = "Type u Fenwell 0 ~ +150 Celisus"
    gsRangeCode(&H63) = "YSI L Mix 100 @ 25XC -80 ~ 10"
    gsRangeCode(&H64) = "YSI L Mix 300 @ 25XC -80 ~ 100"
    gsRangeCode(&H65) = "YSI L Mix 1000 @ 25XC -70 ~ 100"
    gsRangeCode(&H66) = "YSI B Mix 2252 @ 25XC -50 ~ 150"
    gsRangeCode(&H67) = "YSI B Mix 3000 @ 25XC -40 ~ 150"
    gsRangeCode(&H68) = "YSI B Mix 5000 @ 25XC -40 ~ 150"
    gsRangeCode(&H69) = "YSI B Mix 6000 @ 25XC -30 ~ 150"
    gsRangeCode(&H6A) = "YSI B Mix 10000 @ 25XC -30 ~ 150"
    gsRangeCode(&H6B) = "YSI H Mix 10000 @ 25XC -30 ~ 150"
    gsRangeCode(&H6C) = "YSI H Mix 30000 @ 25XC -10 ~ 200"
    gsRangeCode(&H70) = "0x70 User-defined -50 ~ 150"
    gsRangeCode(&H71) = "0x71 User-defined -50 ~ 150"
    gsRangeCode(&H72) = "0x72 User-defined -50 ~ 150"
    gsRangeCode(&H73) = "0x73 User-defined -50 ~ 150"
    gsRangeCode(&H74) = "0x74 User-defined -50 ~ 150"
    gsRangeCode(&H75) = "0x75 User-defined -50 ~ 150"
    gsRangeCode(&H76) = "0x76 User-defined -50 ~ 150"
    gsRangeCode(&H77) = "0x77 User-defined -50 ~ 150"
    Beep
End Sub

Public Sub UpdateModuleDisplay(ByVal Index%, ByVal NewAddress%, ByVal Checksum, ByVal lBaudrate As Long)
    Dim a$, Addr$, b$, c$
    Dim iii As Integer
    
    ModuleConfig(gSetupModuleIndex).ModuleAddress = NewAddress
    
    
    Debug.Print gModuleInformation(Index)
    
    a$ = Left(gModuleInformation(Index), 6)
    Addr$ = str(NewAddress) & "[" & Hex(NewAddress) & "]"
    b$ = Space(9 - Len(Addr$)) & Right(gModuleInformation(Index), 65)
    
    gItemX.SubItems(1) = Addr$
    gItemX.SubItems(2) = str(lBaudrate)
    If Checksum Then
        gItemX.SubItems(4) = "Enable"
    Else
        gItemX.SubItems(4) = "Disable"
    End If

    
'    Debug.Print A$
'    Debug.Print Addr$
'    Debug.Print B$
'    Debug.Print A$ + Addr$ + B$
    gModuleInformation(Index) = a$ + Addr$ + b$
    
End Sub
Public Sub Update70XXModuleDisplay(ByVal Index%, ByVal NewAddress%, ByVal Checksum, _
                                    inputRange As String, ByVal lBaudrate As Long)
    Dim a$, Addr$, b$, c$, d$, E$
    Dim iii%, length%
    
    ModuleConfig(gSetupModuleIndex).ModuleAddress = NewAddress
    ModuleConfig(gSetupModuleIndex).BaudRate = lBaudrate
    ModuleConfig(gSetupModuleIndex).Checksum = Checksum
    Debug.Print gModuleInformation(Index)
    
    a$ = Left(gModuleInformation(Index), 6)
    Addr$ = str(NewAddress) & "[" & Hex(NewAddress) & "]"
    b$ = Space(9 - Len(Addr$)) & str(lBaudrate)
    If gWinCon = 0 Then
        gItemX.SubItems(1) = Addr$
    End If
    gItemX.SubItems(2) = str(lBaudrate)
    
    
    length = Len(str(lBaudrate))
            
    Select Case Left(a$, 4)
       Case "4011", "7011", "4012", "7012", "4014", "7014", "4016", "7016"
            Debug.Print "Update70XX:" + Left(a$, 4)
            Select Case ModuleConfig(Index).CounterAlarmState(0)
                Case 0
                    d$ = Space(8 - length) + "Disable  "
                    gItemX.SubItems(3) = "Disable"
                Case 1
                    d$ = Space(8 - length) + "Momentary"
                    gItemX.SubItems(3) = "Momentary"
                Case 2
                    d$ = Space(8 - length) + "Latch    "
                    gItemX.SubItems(3) = "Latch"
            End Select
            If Checksum Then
                E$ = "  Enable        " + inputRange
                gItemX.SubItems(4) = "Enable"
            Else
                E$ = "  Disable       " + inputRange
                gItemX.SubItems(4) = "Disable"
            End If
            gItemX.SubItems(5) = inputRange
            Debug.Print "Update70XX:" + Left(a$, 4) + "   " + d$ + E$
            gModuleInformation(Index) = a$ + Addr$ + b$ + d$ + E$
      Case "7019"
          If Checksum Then
              c$ = Space(19 - length) + "Enabled " + Space(3) + inputRange
              gItemX.SubItems(4) = "Enable"
          Else
              c$ = Space(19 - length) + "Disable" + Space(3) + inputRange
              gItemX.SubItems(4) = "Disable"
          End If
      
      Case Else
            ' C$ = Space(33 - length) + InputRange
          If Checksum Then
              c$ = Space(19 - length) + "Enabled " + Space(3) + inputRange
              gItemX.SubItems(4) = "Enable"
          Else
              c$ = Space(19 - length) + "Disable" + Space(3) + inputRange
              gItemX.SubItems(4) = "Disable"
          End If
          gItemX.SubItems(5) = inputRange
          gModuleInformation(Index) = a$ + Addr$ + b$ + c$
    End Select
   
End Sub


Public Sub Update7080ModuleDisplay(ByVal Index%, ByVal NewAddress%, ByVal Checksum, _
                                    ByVal ModuleMode%, ByVal lBaudrate As Long)
    Dim a$, Addr$, b$, c$, d$
    Dim iii%, length%
    
    ModuleConfig(gSetupModuleIndex).ModuleAddress = NewAddress
    
    Debug.Print gModuleInformation(Index)
    
    a$ = Left(gModuleInformation(Index), 6)
    Addr$ = str(NewAddress) & "[" & Hex(NewAddress) & "]"
    b$ = Space(9 - Len(Addr$)) & str(lBaudrate)
    
    length = Len(str(lBaudrate))
    
    If Checksum Then
        c$ = Space(19 - length) + "Enable "
    Else
        c$ = Space(19 - length) + "Disable"
    End If
    
    If ModuleMode = 0 Then
        d$ = Space(7) + "Counter Mode"
    Else
        d$ = Space(7) + "Frequency Mode"
    End If
        
    gModuleInformation(Index) = a$ + Addr$ + b$ + c$ + d$
    
End Sub
Public Sub SetIni(ByVal FileStr As String, ByVal SectStr As String, ByVal KeyStr As String, ByVal valstr As String)
    WritePrivateProfileString SectStr, KeyStr, valstr, App.Path & "\" & FileStr & ".ini"
End Sub

Public Sub GetIni(ByVal FileStr As String, ByVal SectStr As String, ByVal KeyStr As String, ByRef valstr As String)
    valstr = Space(255)
    GetPrivateProfileString SectStr, KeyStr, "xxxx", valstr, 255, App.Path & "\" & FileStr & ".ini"
End Sub

Public Function FileExist(FileName As String) As Integer
    Dim RetVal As Integer
    Dim OpenFileStructure As OFSTRUCT
    Const OF_EXIST = &H4000
    Const FILE_NOT_FOUND = 2
    
    RetVal = OpenFile(FileName$, OpenFileStructure, OF_EXIST)
    If OpenFileStructure.nErrCode = FILE_NOT_FOUND Then
        FileExist = False
    Else
        FileExist = True
    End If

End Function
Public Sub toReport(data As String, count As Long, Name As String, rec As String, span As Long)
'oq{DnΨӧ@Debugγ~

Dim FileName As String
Dim RetVal As Integer
Dim finalstr As String
    If Name = "" Then
        Name = "Monitor_Log.txt"
    End If
    finalstr = format(count, "0000000000") + Space(1) + rec + Space(1) + format(span, "00000000") + Space(1) + data
    FileName = App.Path + "\" + Name
    RetVal = FileExist(FileName)
    If RetVal Then  ' ICPCON.CFG file exist !!!
        Open Name For Append As #6
                Print #6, finalstr
        Close #6
    Else
        Open Name For Append As #6
'            Print #6, "Reason,   data,   time"
            Print #6, finalstr
        Close #6
    End If
End Sub
Public Sub toDebug(rec As String)
'oq{DnΨӧ@Debugγ~

Dim Name As String
Dim RetVal As Integer
Dim finalstr As String
    If Name = "" Then
        Name = "Search_Debug_Log.txt"
    End If
    
    Name = App.Path + "\" + Name
    RetVal = FileExist(Name)
    If RetVal Then  ' ICPCON.CFG file exist !!!
        Open Name For Append As #6
                Print #6, rec
        Close #6
    Else
        Open Name For Append As #6
'            Print #6, "Reason,   data,   time"
            Print #6, rec
        Close #6
    End If
End Sub

Public Sub ReadCfgFile()
On Error GoTo openError
    Dim RetVal As Integer
    Dim FileName$
    FileName$ = App.Path + "\icpcon.cfg"
    
    RetVal = FileExist(FileName$)
    If RetVal Then  ' ICPCON.CFG file exist !!!
        Open FileName$ For Input As #1
        Input #1, gPort, gBaudRateSelect, gChecksumSearch, gTimeoutTick
        Close #1
    Else
        MsgBox ("File Not exist !!!" & FileName)
        gPort = 2
        gBaudRate = 9600
        gBaudRateSelect = 2 ^ 7 ' default the baudrate is 9600
        gChecksumSearch = 0     ' default not search checksum enabled module
        gTimeoutTick = 400
    End If
    Exit Sub
openError:
    Close #1
    MsgBox "Open File Error!!!" + vbCrLf + _
    "The ICPCON.CFG Is Empty Or Wrong Setting !!" + vbCrLf + FileName

End Sub


Public Sub DescribeErrorCode(ModuleName As String, ByVal ErrorCode%)
    Dim a$, b$
    
    a$ = "Error in Module: " + ModuleName
    a$ = a$ + "  Error Code: " + str(ErrorCode)
    Select Case ErrorCode
        Case 1
            b$ = "    Function Error !"
        Case 2
            b$ = "    COM Port Error !"
        Case 3
            b$ = "    Baud Rate Error !"
        Case 4
            b$ = "    Data Bit Error !"
        Case 5
            b$ = "    Stop Bit Error !"
        Case 6
            b$ = "    Parity Error !"
        Case 7
            b$ = "    Checksum Error !"
        Case 8
            b$ = "    COM Port not open !"
        Case 9
            b$ = "    Create Thread Error !"
        Case 10
            b$ = "    SendCom Error !"
        Case 11
            b$ = "    ReadComStatus Error !"
        Case 12
            b$ = "    ResultStrCheck Error !"
        Case 13
            b$ = "    Cmd Error !"
        Case 14
            b$ = "    Error Code 14 !"
        Case 15
            b$ = "    Time Out !"
        Case 16
            b$ = "    Error Code 16 !"
        Case 17
            b$ = "    ModuleID Error !"
        Case 18
            b$ = "    AD Channel Error !"
        Case 19
            b$ = "    Under Input Range !"
        Case 20
            b$ = "    Exceed Input Range !"
        Case 21
            b$ = "  Invalidate Counter No !"
        Case 22
            b$ = "  Invalidate Counter Value !"
    End Select
    MDIForm1.StatusBar1.Panels(1).Text = a$ + b$
End Sub
Public Sub DescribeErrorCodeReason(ModuleName As String, ByVal ErrorCode As Integer, ByVal reason As String)
    Dim a$, b$
    
    a$ = "Error in Module: " + ModuleName
    a$ = a$ + "  Error Code: " + str(ErrorCode)
    Select Case ErrorCode
        Case 1
            b$ = "    Function Error !"
        Case 2
            b$ = "    COM Port Error !"
        Case 3
            b$ = "    Baud Rate Error !"
        Case 4
            b$ = "    Data Bit Error !"
        Case 5
            b$ = "    Stop Bit Error !"
        Case 6
            b$ = "    Parity Error !"
        Case 7
            b$ = "    Checksum Error !"
        Case 8
            b$ = "    COM Port not open !"
        Case 9
            b$ = "    Create Thread Error !"
        Case 10
            b$ = "    SendCom Error !"
        Case 11
            b$ = "    ReadComStatus Error !"
        Case 12
            b$ = "    ResultStrCheck Error !"
        Case 13
            b$ = "    Cmd Error !"
        Case 14
            b$ = "    Error Code 14 !"
        Case 15
            b$ = "    Time Out !"
        Case 16
            b$ = "    Error Code 16 !"
        Case 17
            b$ = "    ModuleID Error !"
        Case 18
            b$ = "    AD Channel Error !"
        Case 19
            b$ = "    Under Input Range !"
        Case 20
            b$ = "    Exceed Input Range !"
        Case 21
            b$ = "  Invalidate Counter No !"
        Case 22
            b$ = "  Invalidate Counter Value !"
    End Select
    MDIForm1.StatusBar1.Panels(1).Text = a$ + b$ + reason
End Sub

Public Sub DescribeBrokenLineError(ModuleName As String, channel As Integer, ByVal ErrorCode%)
    Dim a$, b$
    
    a$ = "Warning in Module: " + Trim(ModuleName) '+ " Check connection of channel" + str(channel)
    a$ = a$ + "  Error Code: " + str(ErrorCode)
    Select Case ErrorCode
        Case 19
            b$ = "    Under Input Range !"
        Case 20
            b$ = "    Exceed Input Range !"
    End Select
    MDIForm1.StatusBar1.Panels(1).Text = a$ + b$
End Sub


Public Function MakeDWord(wHi As Integer, wLo As Integer) As Long
    Dim HiPart As Long
    
    If wHi And &H8000& Then
        HiPart = (wHi And &H7FFF&) * 65536
        MakeDWord = (HiPart + (wLo And &HFFFF&)) Or &H80000000
    Else
        If wLo And &H8000 Then
            MakeDWord = (wHi * 65536) Or (wLo And &H7FFF) Or &H8000&
        Else
            MakeDWord = (wHi * 65536) + wLo
        End If
    End If
End Function

Public Function MakeDouble(wHi As Integer, wLo As Integer) As Double
    Dim HiPart As Double
    
    If wHi And &H8000& Then
        HiPart = CDbl((wHi And &H7FFF&) * 65536)
        MakeDouble = CDbl(HiPart + (wLo And &HFFFF&)) - CDbl(&H80000000)
    Else
        If wLo And &H8000 Then
            MakeDouble = CDbl((wHi * 65536) Or (wLo And &H7FFF) Or &H8000&)
        Else
            MakeDouble = CDbl((wHi * 65536) + wLo)
        End If
    End If
End Function


Public Sub getIOChannel(id_ As String)
    Select Case id_


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''DI
        Case "8040", "87040", "5040"
            gMIOChannel.DIChannel = 32
            gMIOChannel.DOChannel = 0
            
        Case "8051", "8053", "5051", "5053", "87051", "87053", "8050" _
                , "7051", "7053", "4053"
            gMIOChannel.DIChannel = 16
            gMIOChannel.DOChannel = 0

        Case "7041"
            gMIOChannel.DIChannel = 14
            gMIOChannel.DOChannel = 0

        Case "8052", "8058", "5052", "5058", "87052", "87058" _
                , "7052", "7058", "4052", "4058"
            gMIOChannel.DIChannel = 8
            gMIOChannel.DOChannel = 0
            
            
            
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''DO
                       
        Case "8041", "87041", "5041"
            gMIOChannel.DIChannel = 0
            gMIOChannel.DOChannel = 32
            
        Case "8037", "8056", "8057", "5056", "5057", "87057", "7043", "7045", "5037"
            gMIOChannel.DIChannel = 0
            gMIOChannel.DOChannel = 16
            
        Case "7045"
            gMIOChannel.DIChannel = 0
            gMIOChannel.DOChannel = 14

        Case "7042"
            gMIOChannel.DIChannel = 0
            gMIOChannel.DOChannel = 13
            

        Case "8064", "8065", "8066", "8068", "8069", "5064" _
                , "5065", "5066", "5068", "5069", "87064" _
                , "87065", "87066", "87068", "87069"
            gMIOChannel.DIChannel = 0
            gMIOChannel.DOChannel = 8
            
        Case "7066", "7067", "4066", "4067"
            gMIOChannel.DIChannel = 0
            gMIOChannel.DOChannel = 7
            
        Case "8060", "5060"
            gMIOChannel.DIChannel = 0
            gMIOChannel.DOChannel = 6
            
'''''''''''''''''''''''''''''''''''''''''''''''''''DIO
        Case "8042", "5042"
            gMIOChannel.DIChannel = 16
            gMIOChannel.DOChannel = 16

        
        Case "8054", "8055", "8077", "5054", "5055", "87054", "87055" _
                , "7055"
            gMIOChannel.DIChannel = 8
            gMIOChannel.DOChannel = 8
            
        Case "8063", "5063", "87063", "7060", "M7060", "4060"
            gMIOChannel.DIChannel = 4
            gMIOChannel.DOChannel = 4
            
        Case "7044"
            gMIOChannel.DIChannel = 4
            gMIOChannel.DOChannel = 8
            
        Case "7050", "4050"
            gMIOChannel.DIChannel = 7
            gMIOChannel.DOChannel = 8
        
        Case "7063", "4063"
            gMIOChannel.DIChannel = 8
            gMIOChannel.DOChannel = 3
            
        Case "7065", "4065"
            gMIOChannel.DIChannel = 4
            gMIOChannel.DOChannel = 5
            
            
        Case "7011", "7012", "7014"
            gMIOChannel.AIChannel = 1
            gMIOChannel.DOChannel = 2
            gMIOChannel.DIChannel = 1
        Case "7013"
            gMIOChannel.AIChannel = 1
            gMIOChannel.DOChannel = 0
       
          
            
'        Case "7016"
'            If InStr(1, s_specialF, "P", vbTextCompare) > 0 Then
'                gMIOChannel.AIChannel = 1
'            Else
'                gMIOChannel.AIChannel = 2
'            End If
'            gMIOChannel.DOChannel = 4
            
        Case "87013", "8013"
            gMIOChannel.AIChannel = 4
            gMIOChannel.DOChannel = 0
            
        Case "7015"
            gMIOChannel.AIChannel = 6
            gMIOChannel.DOChannel = 0
            
        Case "7019", "8017", "8018", "8017H", "7017", "7018", "87017", "87018", "4017", "4018"
            gMIOChannel.AIChannel = 8
            gMIOChannel.DOChannel = 0
            
        Case "7005"
            gMIOChannel.AIChannel = 8
            gMIOChannel.DOChannel = 6
        Case "7033"
            gMIOChannel.AIChannel = 3
            gMIOChannel.DOChannel = 0
        
            
       

        
        Case Else
            gMIOChannel.DIChannel = 0
            gMIOChannel.DOChannel = 0
    End Select
End Sub
Public Sub getBaudRateTable()
gBaudRateTable(13) = 921600
gBaudRateStr(13) = "0D"
gBaudRateTable(12) = 460800
gBaudRateStr(12) = "0C"
gBaudRateTable(11) = 230400
gBaudRateStr(11) = "0B"
gBaudRateTable(10) = 115200
gBaudRateStr(10) = "0A"
gBaudRateTable(9) = 57600
gBaudRateStr(9) = "09"
gBaudRateTable(8) = 38400
gBaudRateStr(8) = "08"
gBaudRateTable(7) = 19200
gBaudRateStr(7) = "07"
gBaudRateTable(6) = 9600
gBaudRateStr(6) = "06"
gBaudRateTable(5) = 4800
gBaudRateStr(5) = "05"
gBaudRateTable(4) = 2400
gBaudRateStr(4) = "04"
gBaudRateTable(3) = 1200
gBaudRateStr(3) = "03"
End Sub

Public Function getBaudRateIndex(baud As Long) As Long
    Dim i As Integer
        For i = 3 To 13
           If gBaudRateTable(i) = baud Then
                gBaudRateIndex = i
                Exit For
            End If
        Next i
End Function

Public Function getInputRangeIndex(rangestr As String) As Integer
    Dim i As Integer
        For i = &H0 To &H2A
           If gsRangeCode(i) = rangestr Then
                gInputRangeIndex = i
                
            End If
        Next i
End Function


Public Sub getHzRejection()
    gHzRejection(0) = "60Hz rejection" ' 0   'Bit 7 =0
    gHzRejection(1) = "50Hz rejection"  '1   'Bit 7 =1
End Sub
            
Public Sub getDataFormat()
    gDataFormat(0) = "Engineering Unit"
    gDataFormat(1) = "% of FSR"
    gDataFormat(2) = "2's complement"
    gDataFormat(3) = "Ohms"
End Sub

            
Public Sub getInputRange()
    gsRangeCode(0) = "+/- 15 mV"
    gsRangeCode(1) = "+/- 50 mV"
    gsRangeCode(2) = "+/- 100 mV"
    gsRangeCode(3) = "+/- 500 mV"
    gsRangeCode(4) = "+/- 1.0 V"
    gsRangeCode(5) = "+/- 2.5 V"
    gsRangeCode(6) = "+/- 20 mA"
    gsRangeCode(7) = "+/- 1.25 V"
    gsRangeCode(8) = "+/- 10 V"
    gsRangeCode(9) = "+/- 5 V"
    gsRangeCode(&HA) = "+/- 1 V"
    gsRangeCode(&HB) = "+/- 500 mV"
    gsRangeCode(&HC) = "+/- 150 mV"
    gsRangeCode(&HD) = "+/- 20 mA"
    gsRangeCode(&HE) = "T/C J-type"
    gsRangeCode(&HF) = "T/C K-type"
    gsRangeCode(&H10) = "T/C T-type"
    gsRangeCode(&H11) = "T/C E-type"
    gsRangeCode(&H12) = "T/C R-type"
    gsRangeCode(&H13) = "T/C S-type"
    gsRangeCode(&H14) = "T/C B-type"
    gsRangeCode(&H15) = "T/C N-type"
    gsRangeCode(&H16) = "T/C C-type"
    gsRangeCode(&H17) = "T/C L-type"
    gsRangeCode(&H18) = "T/C M-type"
    gsRangeCode(&H19) = "T/C L2-type"
    gsRangeCode(&H20) = "+/- 100 ,PT 100 a=0.00385"
    gsRangeCode(&H21) = "0 ~ +100 ,PT 100 a=0.00385"
    gsRangeCode(&H22) = "0 ~ +200 ,PT 100 a=0.00385"
    gsRangeCode(&H23) = "0 ~ +600 ,PT 100 a=0.00385"
    gsRangeCode(&H24) = "+/- 100 ,PT 100 a=0.003916"
    gsRangeCode(&H25) = "0 ~ +100 ,PT 100 a=0.003916"
    gsRangeCode(&H26) = "0 ~ +200 ,PT 100 a=0.003916"
    gsRangeCode(&H27) = "0 ~ +600 ,PT 100 a=0.003916"
    gsRangeCode(&H28) = "-80 ~ +600 ,Nickel 120"
    gsRangeCode(&H29) = "0 ~ +100 ,Nickel 120"
    gsRangeCode(&H2A) = "-200 ~ +600 ,PT 1000 a=0.00385"
'    gsRangeCode(&H30) = "0 ~ +20 mA"
'    gsRangeCode(&H31) = "+4 ~ +20 mA"
'    gsRangeCode(&H32) = "0 ~ +10 V"
'    gsRangeCode(&H33) = "+/- 10 V"
'    gsRangeCode(&H34) = "0 ~ +5 V"
'    gsRangeCode(&H35) = "+/- 5 V"

End Sub

